#!/usr/bin/perl
#-----------------------------------------------------------------------------
# AWStats plugin: whovisited AWStats plugin
#
# Based on InternetOfficer Follow Me plugin
#
#-----------------------------------------------------------------------------
# Perl Required Modules: none
#-----------------------------------------------------------------------------
# $Revision: 1.20 $ - $Author: InternetOfficer SPRL $ - $Date: 2010/12/14 15:30:00 $

# <-----
# ENTER HERE THE USE COMMAND FOR ALL REQUIRED PERL MODULES.
# ----->
#use strict;
no strict "refs" ;


#-----------------------------------------------------------------------------
# PLUGIN VARIABLES
#-----------------------------------------------------------------------------
# <-----
# ENTER HERE THE MINIMUM AWSTATS VERSION REQUIRED BY YOUR PLUGIN
# AND THE NAME OF ALL FUNCTIONS THE PLUGIN MANAGE.
my $PluginNeedAWStatsVersion = "6.6" ;
my $PluginHooksFunctions = "ShowPagesAddField BuildFullHTMLOutput" ;
# ----->

# <-----
# IF YOUR PLUGIN NEED GLOBAL VARIABLES, THEY MUST BE DECLARED HERE.
use vars qw/
@logfile_list
$internetofficer_pluginname_2 $internetofficer_pluginurl_2 $internetofficer_pluginversion_2
/;
# ----->

$internetofficer_pluginname_2 = 'whovisited' ;
$internetofficer_pluginurl_2 = 'http://www.internetofficer.com/awstats/' ;
$internetofficer_pluginversion_2 = '1.2' ;
&internetofficer_language_extension_2 ;

#-----------------------------------------------------------------------------
# PLUGIN FUNCTION: Init_pluginname
#-----------------------------------------------------------------------------
sub Init_whovisited {
	my $InitParams=shift;
	my $checkversion=&Check_Plugin_Version($PluginNeedAWStatsVersion);

	# <-----
	# ENTER HERE CODE TO DO INIT PLUGIN ACTIONS
	debug(' Plugin ' . $internetofficer_pluginname_2 . ': InitParams=' . $InitParams, 1) ;
	my $i = 0 ;	
	my $InitParamsSpace = $InitParams . ' ' ;
	while ( $InitParamsSpace =~ m/(\[([^\[\]]+)\]|([^ ]+)) +/g ) {
		$logfile_list[$i] = ($2 ? $2 : $3) ;
		$i++ ;
	}
	# ----->

	return ($checkversion?$checkversion:"$PluginHooksFunctions");
}


#-----------------------------------------------------------------------------
# PLUGIN FUNCTION: ShowInfoHost_pluginname
# UNIQUE: NO (Several plugins using this function can be loaded)
# Function called to add additionnal columns to the Hosts report.
# This function is called when building rows of the report (One call for each
# row). So it allows you to add a column in report, for example with code :
#   print "<TD>This is a new cell for $param</TD>";
# Parameters: Host name or ip
#-----------------------------------------------------------------------------
sub ShowPagesAddField_whovisited {
    my $url="$_[0]";
	# <-----
	if (!$StaticLinks) {
		if ($url eq 'title') {
			print '<th width="40">' . $plugin_message{'Who Visited'} . '</th>' ;	
		} elsif ($url) {
			print '<td><a href="' . $AWScript . '?config=' . $SiteConfig . '&amp;pluginmode=whovisited&amp;url=' . $url 
			. ($Lang ? '&amp;lang=' . $Lang : '') . '" target="_blank">' . $plugin_message{'Zoom'} . '</a>' ;
			print "</td>";
		} else {
			print "<td>&nbsp;</td>";
		}
	}
	return 1;
	# ----->
}


#-----------------------------------------------------------------------------
# PLUGIN FUNTION: BuildFullHTMLOutput_pluginname
# UNIQUE: NO (Several plugins using this function can be loaded)
# Function called to output an HTML page completely built by plugin instead
# of AWStats output
#-----------------------------------------------------------------------------
sub BuildFullHTMLOutput_whovisited {
	# <-----
	my $max_lines = $MaxRowsInHTMLOutput ;
	my $follow_me_host = '' ;
	if ($QueryString =~ /url=([^&]+)/i) { $follow_me_host=&DecodeEncodedString("$1"); }
	if (!$follow_me_host) {
		print '<br />' . $plugin_message{'Missing URL parameter'} . '.<br />&nbsp;<br />' ;
		print '<span dir="ltr" style="font: 11px verdana, arial, helvetica; color: #000000;"><a href="' . $internetofficer_pluginurl_2 . '" target="awstatshome">' . $Message[169] . ' <b>' . $internetofficer_pluginname_2 . ' ' . $internetofficer_pluginversion_2 . '</b></a></span>' ;
		return 1;
	}

	print '<a name="top"></a>' . "\n" ;
	print '<br />' . "\n" ;

	# Header
	print '<table class="aws_border" border="0" cellpadding="2" cellspacing="0" width="100%">
<tr><td>
<table class="aws_data sortable" border="0" cellpadding="1" cellspacing="0" width="100%">
' ;
	print '<tr><td class="aws" valign="middle"><b>' . $Message[7] . ':</b>&nbsp;</td><td class="aws" valign="middle"><span style="font-size: 14px;">' . $SiteDomain . '</span></td>' ;
	# Logos
	print '<td align="right" rowspan="2">' ;
	print '<a href="http://www.internetofficer.com/awstats/" target="awstatshome"><img src="http://www.internetofficer.com/images/internetofficer.png" alt="AWStats by InternetOfficer" border="0" /></a>' . "\n" ;
	print '&nbsp;&nbsp;&nbsp;<a href="' ;
	print XMLEncode($LogoLink) ;
	print '" target="awstatshome"><img src="' . $DirIcons . '/other/' . $Logo . '" border="0"' ;
	if ( $LogoLink =~ "http://awstats.sourceforge.net" ) {
		print ' alt="AWStats Web Site" title="AWStats Web Site"' ;
	}
	print ' /></a>' . "\n" ;
	print '</td></tr>' . "\n" ;
	print '<tr><td class="aws" valign="middle"><b>' . $plugin_message{'URL'} . ':</b>&nbsp;</td><td class="aws" valign="middle"><span style="font-size: 14px;">' . $follow_me_host . '</span></td>' ;
	print '</table>' . "\n" ;
	print '</td></tr></table>' . "\n" ;

	print '<br />' . "\n" ;
	&tab_head ($plugin_message{'Who Visited'}, 0, 0, 'aws');
	print '<tr bgcolor="#ECECEC"><th width="200">' . $plugin_message{'Date and time'} . '</th><th bgcolor="#4477DD" width="80">' . $Message[56] . '</th><th bgcolor="#4477DD">' . $plugin_message{'Other hits'} . '</th></tr>' . "\n" ;

	# Declare and initialize variables
	my %mmm2mon ;
	$mmm2mon{'Jan'} = 0 ; $mmm2mon{'Feb'} = 1 ; $mmm2mon{'Mar'} = 2 ; $mmm2mon{'Apr'} = 3 ; $mmm2mon{'May'} = 4 ; $mmm2mon{'Jun'} = 5 ;
	$mmm2mon{'Jul'} = 6 ; $mmm2mon{'Aug'} = 7 ; $mmm2mon{'Sep'} = 8 ; $mmm2mon{'Oct'} = 9 ; $mmm2mon{'Nov'} = 10 ; $mmm2mon{'Dec'} = 11 ;
	my $host ;
	my $logname ;
	my $time ; my $time4 ;
	my $methodurl ; my $method ; my $url ; my $protocol ; my $query ;
	my $bytesd ;
	my $code ;
	my $refererquot ; my $referer ;
	my $uaquot ; my $ua ;
	my $this_log_separator = ' ' ;
	if ($LogFormat != 1 && $LogFormat != 2 && $LogFormat != 3 && $LogFormat != 4) {
		$this_log_separator = $LogSeparator ;
	}
	my $field1 = '([^ ]+)' . $this_log_separator ;
	my $field2 = '"([^"]+)"' . $this_log_separator ;
	my $field3 = '\[([^\]]+)\]' . $this_log_separator ;
	my $field4 = '([^ ]+' . $this_log_separator . '[^ ]+)' . $this_log_separator ;
	my $refererquot_position = 0 ;
	my $time1_position = 0 ;
	my $time2_position = 0 ;
	my $host_position = 0 ;
	my $methodurl_position = 0 ;
	my $method_position = 0 ;
	my $url_position = 0 ;
	my $protocol_position = 0 ;
	my $query_position = 0 ;
	my $code_position = 0 ;
	my $time0 = 0 ;
	my $time_on_previous_page ;
	my $page_found_in_this_visit = 1 ; # is 0 if there has been a hit on something else than a page, more than 1 hour after the last hit on a page; is 1 in all other cases.

	my $mask_media_extension = '\.(avi|bmp|gif|jpe?g|mpg|mp3|pdf|png|swf|txt|wav|wma|zip)($|\?)' ;
	$mask_media_extension = qr/$mask_media_extension/ ;
	my $mask_misc_extension = '\.(css|js|class|ico|rss|xml)($|\?)' ;
	$mask_misc_extension = qr/$mask_misc_extension/ ;
	
	# Build mask	
	my $mask = '' ;
	if ($LogFormat == 1) {
		$mask = '^' . substr ($field1 . $field1 . $field1 . $field3 . $field2 . $field1 . $field1 . $field2 . $field2, 0, -1) . '$' ;
		$host_position = 1 ;
		$time1_position = 4 ;
		$methodurl_position = 5 ;
		$code_position = 6 ;
		$refererquot_position = 8 ;
	} elsif ($LogFormat == 2) {
		my @iis_format ;
		open (LOG, "$LogFile") || error("Couldn't open server log file \"$LogFile\" : $!");
		binmode LOG;	# Avoid premature EOF due to log files corrupted with \cZ or bin chars
		while (<LOG>) {
			chomp $_; $_ =~ s/\r//;
			if (/^#Fields:/) {
				@iis_format = split (/\s+/, $_) ;
				last;
			}
		}
		if (@iis_format) {
			my @formatmask ;
			my $aws_mask_position = 0 ;
			for ($mask_position=1; $mask_position < @iis_format; $mask_position++) {
				if ($iis_format[$mask_position] eq 'date' && $iis_format[$mask_position+1] eq 'time') {
					$mask .= $field4 ;
					$time2_position = $aws_mask_position + 1 ;
					$mask_position++ ;
				} else {
					$mask .= $field1 ;
					if ($iis_format[$mask_position] eq 'c-ip') {
						$host_position = $aws_mask_position + 1 ;
					} elsif ($iis_format[$mask_position] eq 'sc-status') {
						$code_position = $aws_mask_position + 1 ;
					} elsif ($iis_format[$mask_position] eq 'cs-method') {
						$method_position = $aws_mask_position + 1 ;
					} elsif ($iis_format[$mask_position] eq 'cs-uri-query') {
						$query_position = $aws_mask_position + 1 ;
					} elsif ($iis_format[$mask_position] eq 'cs-uri-stem') {
						$url_position = $aws_mask_position + 1 ;
					} elsif ($iis_format[$mask_position] eq 'cs(Referer)') {
						$referer_position = $aws_mask_position + 1 ;
					}
				}
				$aws_mask_position++ ;
			}
			$mask = '^' . substr ($mask, 0, -1) . '$' ;
		} else {
			print '<br />' . $plugin_message{'IIS format string not found'} . '.<br />&nbsp;<br />' ;
			print '<span dir="ltr" style="font: 11px verdana, arial, helvetica; color: #000000;"><a href="' . $internetofficer_pluginurl_2 . '" target="awstatshome">' . $Message[169] . ' <b>' . $internetofficer_pluginname_2 . ' ' . $internetofficer_pluginversion_2 . '</b></a></span>' ;
			return 1;
		}
	} else {
		my @format_mask = split (/\s+/, $LogFormat) ;
		for ($mask_position=0; $mask_position < @format_mask; $mask_position++) {
			if ($format_mask[$mask_position] eq '%time2') {
				$mask .= $field4 ;
				$time2_position = $mask_position + 1 ;
			} elsif ($format_mask[$mask_position] eq '%methodurl' || $format_mask[$mask_position] =~ /^%\w+quot$/) {
				$mask .= $field2 ;
				if ($format_mask[$mask_position] eq '%refererquot') {
					$refererquot_position = $mask_position + 1 ;
				} elsif ($format_mask[$mask_position] eq '%methodurl') {
					$methodurl_position = $mask_position + 1 ;
				}
			} elsif ($format_mask[$mask_position] eq '%time1') {
				$mask .= $field3 ;
				$time1_position = $mask_position + 1 ;
			} else {
				$mask .= $field1 ;
				if ($format_mask[$mask_position] eq '%host') {
					$host_position = $mask_position + 1 ;
				} elsif ($format_mask[$mask_position] eq '%code') {
					$code_position = $mask_position + 1 ;
				} elsif ($format_mask[$mask_position] eq '%method') {
					$method_position = $mask_position + 1 ;
				} elsif ($format_mask[$mask_position] eq '%query') {
					$query_position = $mask_position + 1 ;
				} elsif ($format_mask[$mask_position] eq '%url') {
					$url_position = $mask_position + 1 ;
				} elsif ($format_mask[$mask_position] eq '%referer') {
					$referer_position = $mask_position + 1 ;
				}
			}
		}
		$mask = '^' . substr ($mask, 0, -1) . '$' ;
	}
	
	if ($mask) { $mask=qr/$mask/; }
	
	my $i = 0 ;
	push (@logfile_list , $LogFile) ;
	foreach my $logfile (@logfile_list) {
		$logfile = &Substitute_Tags($logfile) ;

		open (LOG, "$logfile") || error("Couldn't open server log file \"$logfile\" : $!");
		binmode LOG;	# Avoid premature EOF due to log files corrupted with \cZ or bin chars
		# my $i = 0 ;
		
		while (<LOG>) {
			chomp $_; $_ =~ s/\r//;
			if (/$mask/o) {
				$host = $$host_position ;
				if ($time1_position) { $time = $$time1_position ; }
				if ($time2_position) { $time = $$time2_position ; }
				if ($methodurl_position) { $methodurl = $$methodurl_position ; }
				if ($method_position) { $method = $$method_position ;  }
				if ($url_position) { $url = $$url_position ; }
				if ($query_position) { $query = $$query_position ; }
				$code = $$code_position ;
				if ($refererquot_position) { $referer = $$refererquot_position ; }
				if ($referer_position) { $referer = $$referer_position ; }
			} else {
				$host = '' ;
			}

			if ($methodurl =~ /^(\w+) ([^ ]+) (HTTP.*)$/) {
				$method = $1 ;
				$url = $2 ;
				$protocol = $3 ;
			} elsif ($url) {
				if ($query && $query ne '-') {
					$url .= '?' . $query ;
				}
			} else {
				$method = '' ;
				$url = 'invalid URL field' ;
				$protocol = '' ;
			}

			if ($follow_me_host ne substr($url,0,length($follow_me_host))) { next; }
			
			{
				print '<tr><td>' . $time . '</td>' . "\n" ;

$filename = '/var/lib/awstats/dnscachelastupdate.' . $SiteDomain . '.txt';
if (open(FILE, $filename)) {
        while(<FILE>)
        {
                chomp;
                @fields = split('\t', $_);
                if (lc($fields[1]) eq $host) { if ($fields[2] ne "*") { $host = $fields[2]; } }
        }
        close FILE;
}
				
				print '<td colspan="2" class="aws">' . &url_with_color($host, 'blue') ;
				
				if ($method ne 'GET') {
					print ' (' . $method . ')' ;
				}
				my $code1 = substr($code,0,1) ;
				if ($code != 200 && $code != 304) {
					if ($code1 eq '4' || $code1 eq '5' ) {
						print ' <font color="red">' . $code . ' ' . $plugin_message{'error'} . '</font>' ;
					} elsif ($code1 eq '3') {
						print ' ' . $code . ' ' . $plugin_message{'redirection'} ;
					} elsif ($code == 206) {
						print ' ' . $code . ' ' . $plugin_message{'partial download'} ;
					} else{
						print ' <font color="red">' . $code . ' ' . $plugin_message{'unknown status code'} . '</font>' ;
					}
				}
				print '</td></tr>' . "\n" ;
				print '<tr><td>&nbsp;</td><td colspan="2" class="aws">' ;
				print $plugin_message{'coming from'} . ' ' . &url_with_color($referer, 'gray') . "\n" ;
				print '</td></tr>' . "\n" ;
			}

			if (++$i == $max_lines) {
				print '<tr><td colspan="3"><strong>Maximum number of lines ' . $max_lines . ' has been reached</strong></td></tr>' . "\n" ;
				last;
			}
		}
		close (LOG) ;
	}

	if ($i == 0) {
		if (@logfile_list == 1) {
			print '<tr><td colspan="3"><strong>' . $plugin_message{'No data for this URL found in'} . '</strong> ' . $logfile_list[0] . '</td></tr>' . "\n" ;
		} else {
			print '<tr><td colspan="3"><strong>' . $plugin_message{'No data for this URL found in'} . ' :</strong></td></tr>' . "\n" ;
			foreach (@logfile_list) {
				print '<tr><td colspan="3">' . $_ . '</td></tr>' . "\n" ;
			}
		}
	}
	
	&tab_end ;

	print '<span dir="ltr" style="font: 11px verdana, arial, helvetica; color: #000000;"><a href="' . $internetofficer_pluginurl_2 . '" target="awstatshome">' . $Message[169] . ' <b>' . $internetofficer_pluginname_2 . ' ' . $internetofficer_pluginversion_2 . '</b></a></span>' ;

	return 1;
	# ----->
}


#------------------------------------------------------------------------------
# Function:     Write URL in color
# Parameters:   $url $color
# Input:        %Aliases $MaxLengthOfShownURL $ShowLinksOnUrl $SiteDomain $UseHTTPSLinkForUrl
# Output:       None
# Return:       URL link
# Source:       inspired by ShowURLInfo from awstats.pl (version 6.95)
#------------------------------------------------------------------------------
sub url_with_color {
	my $url     = shift ;
	my $color   = shift ;
	my $nompage = CleanXSS($url);

	if ( length($nompage) > $MaxLengthOfShownURL ) {
		$nompage = substr( $nompage, 0, $MaxLengthOfShownURL ) . "...";
	}
	if ($ShowLinksOnUrl) {
		my $newkey = CleanXSS($url);

		if ( $newkey =~ /^http(s|):/i ) {
		# URL seems to be extracted from a proxy log file
			return ('<a href="' . XMLEncode("$newkey") . '" target="url">' . '<font color="' . $color . '">' . XMLEncode($nompage) . '</font></a>') ;
		} elsif ( $newkey =~ /^\// ) {
		# URL seems to be an url extracted from a web or wap server log file
			$newkey =~ s/^\/$SiteDomain//i;
			# Define urlprot
			my $urlprot = 'http';
			if ( $UseHTTPSLinkForUrl && $newkey =~ /^$UseHTTPSLinkForUrl/ ) { $urlprot = 'https' ; }
			return ('<a href="' . XMLEncode("$urlprot://$SiteDomain$newkey") . '" target="url">' . '<font color="' . $color . '">' . XMLEncode($nompage) . '</font></a>') ;
		} else {
			return ('<font color="' . $color . '">' . XMLEncode($nompage) . '</font>') ;
		}
	} else {
		return ('<font color="' . $color . '">' . XMLEncode($nompage) . '</font>') ;
	}
}


#-----------------------------------------------------------------------------
# Texts for use with the plugin
#-----------------------------------------------------------------------------
sub internetofficer_language_extension_2 {
	$plugin_message{'Host'} = 'Host' ;
	$plugin_message{'URL'} = 'URL' ;
	$plugin_message{'Follow Me'} = 'Follow Me' ;
	$plugin_message{'Who Visited'} = 'Who Visited' ;
	$plugin_message{'Zoom'} = 'Zoom' ;
	$plugin_message{'Date and time'} = 'Date and time' ;
	$plugin_message{'Other hits'} = 'Other hits' ;
	$plugin_message{'NEW VISIT'} = 'NEW VISIT' ;
	$plugin_message{'error'} = 'error' ;
	$plugin_message{'redirection'} = 'redirection' ;
	$plugin_message{'partial download'} = 'partial download' ;
	$plugin_message{'unknown status code'} = 'unknown status code' ;
	$plugin_message{'coming from'} = 'coming from' ;
	$plugin_message{'after'} = 'after' ;
	$plugin_message{'seconds'} = 'seconds' ;
	$plugin_message{'Missing host parameter'} = 'Missing host parameter' ;
	$plugin_message{'Missing URL parameter'} = 'Missing URL parameter' ;
	$plugin_message{'IIS format string not found'} = 'IIS format string not found' ;
	$plugin_message{'No data for this host found in'} = 'No data for this host found in' ;
	$plugin_message{'No data for this URL found in'} = 'No data for this URL found in' ;
	if ($Lang eq 'fr') {
		$plugin_message{'Host'} = 'Hote' ;
		$plugin_message{'URL'} = 'URL' ;
		$plugin_message{'Follow Me'} = 'Follow Me' ;
		$plugin_message{'Who Visited'} = 'Who Visited' ;
		$plugin_message{'Zoom'} = 'Zoom' ;
		$plugin_message{'Date and time'} = 'Date et heure' ;
		$plugin_message{'Other hits'} = 'Autres hits' ;
		$plugin_message{'NEW VISIT'} = 'NOUVELLE VISITE' ;
		$plugin_message{'error'} = 'erreur' ;
		$plugin_message{'redirection'} = 'redirection' ;
		$plugin_message{'partial download'} = 't&eacute;l&eacute;chargement partiel' ;
		$plugin_message{'unknown status code'} = 'code inconnu' ;
		$plugin_message{'coming from'} = 'venant de' ;
		$plugin_message{'after'} = 'apr&egrave;s' ;
		$plugin_message{'seconds'} = 'secondes' ;
		$plugin_message{'Missing host parameter'} = 'Param&egrave;tre hote non d&eacute;fini' ;
		$plugin_message{'Missing URL parameter'} = 'Param&egrave;tre URL non d&eacute;fini' ;

		$plugin_message{'IIS format string not found'} = 'Aucune ligne de d&eacute;finition du format IIS n\'a &eacute;t&eacute; trouv&eacute;e' ;
		$plugin_message{'No data for this host found in'} = 'Aucune donn&eacute;e trouv&eacute;e pour cette hote dans' ;
		$plugin_message{'No data for this URL found in'} = 'Aucune donn&eacute;e trouv&eacute;e pour cette URL dans' ;
	} elsif ($Lang eq 'nl') {
		$plugin_message{'Host'} = 'Host' ;
		$plugin_message{'URL'} = 'URL' ;
		$plugin_message{'Follow Me'} = 'Follow Me' ;
		$plugin_message{'Who Visited'} = 'Who Visited' ;
		$plugin_message{'Zoom'} = 'Zoom' ;
		$plugin_message{'Date and time'} = 'Datum en tijd' ;
		$plugin_message{'Other hits'} = 'Andere hits' ;
		$plugin_message{'NEW VISIT'} = 'NIEUW BEZOEK' ;
		$plugin_message{'error'} = 'foutcode' ;
		$plugin_message{'redirection'} = 'redirect' ;
		$plugin_message{'partial download'} = 'gedeeltelijke inhoud' ;
		$plugin_message{'unknown status code'} = 'onbekende statuscode' ;
		$plugin_message{'coming from'} = 'komende van' ;
		$plugin_message{'after'} = 'na' ;
		$plugin_message{'seconds'} = 'seconden' ;
		$plugin_message{'Missing host parameter'} = 'host parameter niet aanwezig' ;
		$plugin_message{'Missing URL parameter'} = 'URL parameter niet aanwezig' ;
		$plugin_message{'IIS format string not found'} = 'IIS formaat specificatie niet gevonden' ;
		$plugin_message{'No data for this host found in'} = 'Geen gegevens van deze host gevonden in' ;
		$plugin_message{'No data for this URL found in'} = 'Geen gegevens van deze URL gevonden in' ;
	}
}


1;	# Do not remove this line

